{% extends "wizard/base.html" %}
{% block title %}Step 2: Authentication{% endblock %}
{% block step_content %}
  <div class="row">
    <div class="col-12">
      <h1 class="mt-5">Step 2: Authentication</h1>
      <p>Authentication for your app is handled by STRAP, so you don&apos;t have to worry about passwords, multifactor authentication, or user registration and confirmation emails. <a href="#">Learn how it works</a>.</p>
      <p>Choose from:</p>
      <ul>
        <li><strong>No authentication</strong>: your app doesn&apos;t need it</li>
        <li><strong>UVic</strong>: My UVic identity can authenticate using UVic's identity service</li>
        <li><strong>UVic + social</strong>: UVic and common public identity providers</li>
      </ul>

      <form method="post">
        {% csrf_token %}

            <!-- Authentication -->
        <div class="mb-3">
          <label class="form-label">Authentication</label>
          <select class="form-control authentication" name='authentication'>
            <option value='' {% if not wizard.app.authentication %}selected{% endif %}>None</option>
            <option value='uvic' {% if wizard.app.authentication == 'uvic' %}selected{% endif %}>UVic</option>
            <option value='uvic_social' {% if wizard.app.authentication == 'uvic_social' %}selected{% endif %}>UVic + Social</option>
          </select>
          <div class="form-text">How the app authenticates users</div>
        </div>

            <!-- Routes -->
        <p>Routes may be authenticated or unauthenticated. For example, the main landing page is often unauthenticated ('/') while the login page requires authentication and so creates an authenticated session for the rest of the site visit.</p>
        <div class="mb-3">
          <label class="form-label">Authenticated routes</label>
          <div class="alert alert-warning d-none" role="alert" data-role="authenticated-routes-alert">
            <i class="fa-solid fa-triangle-exclamation me-2"></i>
            Route exists as an unauthenticated route. Adding this route will remove it from the unauthenticated routes
          </div>
          <div class="routes-input">
            <input
              class="form-control"
              type='text'
              {% if not wizard.app.authentication %}disabled{% endif %}
              placeholder="Type in the route, then click 'Add' to add. E.g. /dashboard, then add"
              data-type="authenticated"></input>
            <div type="button" class="btn btn-primary disabled">Add route</div>
          </div>
          <div class="route-tag-container authenticated-routes">
            {% if wizard.app.authentication %}
              {% if wizard.app.route_set.all|length > 0 %}
                {% for route in wizard.app.route_set.all %}
                  {% if route.authenticated %}
                    <div class="route-tag mt-1"><span class="route-tag-path">{{route.route}}</span> <span class="route-tag-close {% if not wizard.app.authentication %}disabled{% endif %}">&#10005;</span></div>
                  {% endif %}
                {% endfor %}
              {% endif %}
            {% endif %}
          </div>
          <input name="authenticated_routes" class="route-hidden-input d-none authenticated-routes-input" type="text" {% if wizard.app %}value="{{wizard.app.authenticated_routes_to_str}}"{% endif %}>
          <div class="form-text">Routes subject to authentication. Click on the 'X' in each tag to remove it.</div>
        </div>

        <div class="mb-3">
          <label class="form-label">Unauthenticated routes</label>
          <div class="alert alert-warning d-none" role="alert" data-role="unauthenticated-routes-alert">
            <i class="fa-solid fa-triangle-exclamation me-2"></i>
            Route exists as an authenticated route. Adding this route will remove it from the authenticated routes
          </div>
          <div class="routes-input">
            <input
              class="form-control"
              type='text'
              {% if not wizard.app.authentication %}disabled{% endif %}
              placeholder="Type in the route, then click 'Add' to add. E.g. /, then add"
              data-type="unauthenticated"></input>
            <div type="button" class="btn btn-primary disabled">Add route</div>
          </div>
          <div class="route-tag-container unauthenticated-routes">
            {% if not wizard.app.authentication %}
              <div class="route-tag mt-1"><span class="route-tag-path">/</span> <span class="route-tag-close disabled">&#10005;</span></div>
            {% else %}
              {% if wizard.app.route_set.all|length > 0 %}
                {% for route in wizard.app.route_set.all %}
                  {% if not route.authenticated %}
                    <div class="route-tag mt-1"><span class="route-tag-path">{{route.route}}</span> <span class="route-tag-close">&#10005;</span></div>
                  {% endif %}
                {% endfor %}
              {% endif %}
            {% endif %}
          </div>
          <input name="unauthenticated_routes" class="route-hidden-input d-none unauthenticated-routes-input" type="text"
                 {% if wizard.app.authentication %}
                   value="{{wizard.app.unauthenticated_routes_to_str}}"
                 {% else %}
                   value="/"
                 {% endif %}
          >
          <div class="form-text">Routes exempt from authentication. Click on the 'X' in each tag to remove it.</div>
        </div>

            <!-- Navigation buttons -->
        {% with is_form=True %}
          {% include 'wizard/navigation_btns.html' %}
        {% endwith %}
      </form>
    </div>
  </div>
{% endblock %}
